Subject: Re: [PATCH 1/2] midx: fix `BUG()` when getting preferred pack without a reverse index

From: Taylor Blau <[email-masked]>
Date: Thu, 18 Dec 2025 16:13:32 -0500

On Wed, Dec 10, 2025 at 10:40:10AM +0100, Patrick Steinhardt wrote:
> On Tue, Dec 09, 2025 at 07:22:11PM -0500, Taylor Blau wrote:
> > On Mon, Dec 08, 2025 at 07:27:14PM +0100, Patrick Steinhardt wrote:
> > > The function `midx_preferred_pack()` returns the preferred pack for a
> > > given multi-pack index. To compute the preferred pack we:
> > >
> > >   1. Look up the position of the first object indexed by the multi-pack
> > >      index.
> > >
> > >   2. Convert this position from pseudo-pack order into MIDX order.
> > >
> > >   3. We then look up pack that corresponds to this MIDX index.
> >
> > I think the implementation of midx_preferred_pack() works a little bit
> > differently than is described here. I often get confused when working in
> > this area juggling between the various object/pack orderings in my head.
>
> Hm, I feel like I am missing something.
>
> > midx_preferred_pack() cares about converting from the first position in
> > pseudo-pack order back into MIDX object order. To do that, we convert
> > the pseudo-pack position into a MIDX one, and then lookup the pack that
> > represents that object.
>
> Isn't that what I say in (2) and (3)? Or is this about (1) being
> inaccurate? Would this sequence be more accurate:
>
>   1. Take the first position indexed by the MIDX in pseudo-pack order.
>
>   2. Convert this pseudo-pack position into the MIDX position.
>
>   3. We then look up the pack that corresponds to this MIDX position.
>
> In any case, I agree with you that juggling these different positions is
> quite something :)

I was thinking about (1) being inaccurate, but the rephrasing you
provided here and in the new version of the patch look good to me.

Both (2) and (3) from your original patch are correct. I was commenting
here on the phrasing in (1) suggesting we "look up" a position from the
MIDX, which is inaccurate. The position is given as the first position
in pseudo-pack order, and "take the first position" perfectly captures
that.

Thanks,
Taylor